//+------------------------------------------------------------------+
//|                                             trades log v 1.5.mq4 |
//|                                                           brax64 |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window

extern bool    Hidden_mode      = false;
extern bool    Compact_mode     = false;
extern bool    Show_MM          = false;
extern bool    Show_balance     = false;
extern bool    Background       = true;
extern string  Currency_note    = "0=USD, 1=EUR, 2=POUND, 3=YEN";
extern int     Currency_Account = 0;
extern double  Risk             = 2.0;
extern int     Window           = 0;
extern int     Corner           = 0;
extern int     Xpos             = 5;
extern int     Ypos             = 5;
extern int     Window_bal       = 0;
extern int     Corner_bal       = 3;
extern int     Xpos_bal         = 5;
extern int     Ypos_bal         = 5;
extern color   bkgcolor         = C'30,30,30';

int    i, j, dig, dig1, modifier, f_syze, W, C, x, y, ti, w, c, fontsz;
int    x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, y1, a, b;
double sl, tp, pl, pr, total1, total2, bid, ask, factor, bal, eqy, mrg, fmg, mgl;
double stop, size, prcnt, dsl, dtp, lck, scale, pnt, tkv, entry, cl, lots;
string TLOBJ = "TL_v1.5: ", F_TYPE, SYMB, PAIR, LCK, BKG0, BKG1, BKG2;
string PL, PR, SL, TP, RK, MMR, QUOTE, EN, LO, TOT1, TOT2, DSL, DTP, STOP;
color  plcolor, slcolor, tpcolor, t1color, t2color, ecolor;
color  lcolor, qcolor, tcolor, pcolor, eqcolor, rcolor;
color  headcolor    = PaleTurquoise;
color  defaultcolor = DarkGray;
color  Buycolor     = RoyalBlue;
color  Sellcolor    = Crimson;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   string lookFor       = TLOBJ;
   int    lookForLength = StringLen(lookFor);
   for(int i = ObjectsTotal( )- 1; i >= 0; i--)
   {
      string objectName = ObjectName(i);
         if(StringSubstr(objectName, 0, lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   if(Hidden_mode) return(0);
   
   deinit();
   
   if(Xpos < 5) Xpos = 5;
   if(Ypos < 5) Ypos = 5;
   if(Xpos_bal < 5) Xpos_bal = 5;
   if(Ypos_bal < 5) Ypos_bal = 5;

   f_syze = 8;
   F_TYPE = "Anonymous Pro Bold";
   x1  =  60;           // Symbol
   x2  = 130;           // Lots
   x3  = 170;           // Entry
   x4  = 225;           // S/L
   x5  = 320;           // T/P
   x6  = 415;           // Quote, Total
   x7  = 470;           // Pips
   x8  = 520;           // Profit
   x9  = 595;           // MM
   x10 = 110;           // Balance if corner 0 or 2
   x11 =  65;           // Balance if corner 1 or 3   
   y1  =  15;           // y shift
   
   if(Compact_mode)
   {
      Show_MM = false;
      x1 =   5;         // Symbol
      x2 =  75;         // Lots
      x6 =  75;         // Total
      x7 = 115;         // Pips
      x8 = 165;         // Profit
      y1 =  15;         // y shift
   }
   
   W = Window;
   C = Corner;
   j = 0;
   total2 = 0;
   pl = 0;
   pr = 0;
   

   switch(Currency_Account)
   {
      case 0:  SYMB = " $"; break;
      case 1:  SYMB = " "; break;
      case 2:  SYMB = " "; break;
      case 3:  SYMB = " "; break;
      default: SYMB = " $";
   }

   Display(TLOBJ + "T",  "Ticket #",       f_syze, F_TYPE, headcolor, Xpos,      Ypos, Compact_mode);
   Display(TLOBJ + "S",  "Symbol",         f_syze, F_TYPE, headcolor, Xpos + x1, Ypos, false);
   Display(TLOBJ + "L",  "Lots",           f_syze, F_TYPE, headcolor, Xpos + x2, Ypos, false);
   Display(TLOBJ + "E",  "Entry",          f_syze, F_TYPE, headcolor, Xpos + x3, Ypos, Compact_mode);
   Display(TLOBJ + "sl", "Stop Loss",      f_syze, F_TYPE, headcolor, Xpos + x4, Ypos, Compact_mode);
   Display(TLOBJ + "tp", "Take Profit",    f_syze, F_TYPE, headcolor, Xpos + x5, Ypos, Compact_mode);
   Display(TLOBJ + "Q",  "Quote",          f_syze, F_TYPE, headcolor, Xpos + x6, Ypos, Compact_mode);
   Display(TLOBJ + "P",  "Pips",           f_syze, F_TYPE, headcolor, Xpos + x7, Ypos, false);
   Display(TLOBJ + "pr", "Profit " + SYMB, f_syze, F_TYPE, headcolor, Xpos + x8, Ypos, false);
   
   if(Show_MM)
   {
      MMR = StringConcatenate("Money Management - Risk: ", DoubleToStr(Risk, 2), "%");
      Display(TLOBJ + "MM", MMR, f_syze, F_TYPE, headcolor, Xpos + x9, Ypos, Compact_mode);
   }
   
   if(Background)
   {
      BKG0 = StringRepeat("g", 37);
      fontsz = 12;
      if(Compact_mode) BKG0 = StringRepeat("g", 15);
      Display(TLOBJ + "000", BKG0, fontsz, "webdings", bkgcolor, Xpos - 4, Ypos - 4, false);
      if(Show_MM)
      {
         BKG1 = StringRepeat("g", 20);
         Display(TLOBJ + "001", BKG1, fontsz, "webdings", bkgcolor, Xpos + x9 - 8, Ypos - 4, false);
      }
   }
   
   bal = AccountBalance();
   eqy = AccountEquity();
   fmg = AccountFreeMargin();
   
   if(Show_balance)
   {
      eqcolor = Lime;
      if(eqy < bal)  eqcolor = Red;
      if(eqy == bal) eqcolor = WhiteSmoke;
      w = Window_bal;
      c = Corner_bal;
      a = Xpos_bal;
      b = Xpos_bal + x10;
      if(c == 1 || c == 3) {a = Xpos_bal + x11; b = Xpos_bal;}
      
      Display_bal(TLOBJ + "B0",  "Balance" + SYMB,     f_syze, F_TYPE, headcolor,     a, Ypos_bal);
      Display_bal(TLOBJ + "B1",  DoubleToStr(bal, 2),  f_syze, F_TYPE, WhiteSmoke, b, Ypos_bal);
      
      if(Background)
      {
         BKG2 = StringRepeat("g", 8);
         Display_bal(TLOBJ + "006", BKG2, fontsz, "webdings", bkgcolor, Xpos_bal - 4, Ypos_bal - 4);
      }
      
      if(bal != fmg)
      {
         mrg = AccountMargin();      
         mgl = (eqy / mrg) * 100;
         
         Display_bal(TLOBJ + "E0",  "Equity" + SYMB,       f_syze, F_TYPE, headcolor, a, Ypos_bal + y1);
         Display_bal(TLOBJ + "E1",  DoubleToStr(eqy, 2),   f_syze, F_TYPE, eqcolor,   b, Ypos_bal + y1);
         Display_bal(TLOBJ + "FM0", "Free Margin" + SYMB,  f_syze, F_TYPE, headcolor, a, Ypos_bal + y1 * 2);
         Display_bal(TLOBJ + "FM1", DoubleToStr(fmg, 2),   f_syze, F_TYPE, Peru,      b, Ypos_bal + y1 * 2);
         Display_bal(TLOBJ + "M0",  "Margin" + SYMB,       f_syze, F_TYPE, headcolor, a, Ypos_bal + y1 * 3);
         Display_bal(TLOBJ + "M1",  DoubleToStr(mrg, 2),   f_syze, F_TYPE, Peru,      b, Ypos_bal + y1 * 3);
         Display_bal(TLOBJ + "ML0", "Margin Level" + " %", f_syze, F_TYPE, headcolor, a, Ypos_bal + y1 * 4);
         Display_bal(TLOBJ + "ML1", DoubleToStr(mgl, 2),   f_syze, F_TYPE, Peru,      b, Ypos_bal + y1 * 4);
         
         if(Background)
         {
            ObjectDelete(TLOBJ + "006");
            BKG2 = "gg";
            Display_bal(TLOBJ + "007", BKG2, 60, "webdings", bkgcolor, Xpos_bal - 4, Ypos_bal - 4);
         }
      }
   }
   
   for(i = 0; i <= OrdersTotal() - 1; i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true)
      {
         ask   = MarketInfo(OrderSymbol(), MODE_ASK);
         bid   = MarketInfo(OrderSymbol(), MODE_BID);
         dig   = MarketInfo(OrderSymbol(), MODE_DIGITS);
         pnt   = MarketInfo(OrderSymbol(), MODE_POINT);
         tkv   = MarketInfo(OrderSymbol(), MODE_TICKVALUE);
         entry = OrderOpenPrice();
         cl    = OrderClosePrice();
         lots  = OrderLots();
         sl    = OrderStopLoss();
         tp    = OrderTakeProfit();
         ti    = OrderTicket();
         pr    = OrderProfit() + OrderSwap() + OrderCommission();
         
         modifier = 1;
         if(dig == 3 || dig == 5) modifier = 10;
         factor  = pnt * modifier;
         slcolor = defaultcolor;
         tpcolor = defaultcolor;
         lcolor  = defaultcolor;
         tcolor  = defaultcolor;
         ecolor  = Snow;

         EN   = DoubleToStr(entry, dig);
         LO   = StringLeftPad(DoubleToStr(lots, 2), 5, "0");
         PAIR = StringSubstr(OrderSymbol(), 0, 6);
         
         if(pr >= 0) PR = StringLeftPad(StringConcatenate("+", DoubleToStr(pr, 2)), 9, " ");
         else        PR = StringLeftPad(StringConcatenate("-", DoubleToStr(MathAbs(pr), 2)), 9, " ");
         
         y = Ypos + y1 + j*y1; // Total y pos
                          
         if(OrderType() != OP_BUY && OrderType() != OP_SELL)
         {
            plcolor = DimGray; slcolor = DimGray; tpcolor = DimGray; ecolor = DimGray;
            lcolor  = DimGray; qcolor = DimGray; tcolor  = DimGray;
            pl = 0;
            PL = StringRepeat("_", 6);
            PR = StringRepeat("_", 9);
         
            if(OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP)
            {
               pcolor = Buycolor;
               stop   = (entry - sl) / pnt;
               dtp    = (tp - entry) / pnt;
               //pl     = 0;
               STOP   = DoubleToStr(stop, 0);
               DTP    = DoubleToStr(dtp, 0);
               SL     = StringConcatenate(StringLeftPad(DoubleToStr(sl, dig), 7, " "), " (", StringLeftPad(STOP, 4, " "), ")");
               TP     = StringConcatenate(StringLeftPad(DoubleToStr(tp, dig), 7, " "), " (", StringLeftPad(DTP,  4, " "), ")");
               QUOTE  = DoubleToStr(ask, dig);
            
               if(OrderType() == OP_BUYLIMIT)
               {
                  PAIR   = PAIR + " (bl)";
                  if(ask <= entry + (10.01 * factor)) ecolor = Lime;
               }
               
               if(OrderType() == OP_BUYSTOP)
               {
                  PAIR = PAIR + " (bs)";
                  if(ask >= entry - (10.01 * factor)) ecolor = Lime;
               }
            }
         
            if(OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP)
            {
               pcolor = Sellcolor;
               stop   = (sl - entry) / pnt;
               dtp    = (entry - tp) / pnt;
               //pl     = 0;
               STOP   = DoubleToStr(stop, 0);
               DTP    = DoubleToStr(dtp, 0);
               SL     = StringConcatenate(StringLeftPad(DoubleToStr(sl, dig), 7, " "), " (", StringLeftPad(STOP, 4, " "), ")");
               TP     = StringConcatenate(StringLeftPad(DoubleToStr(tp, dig), 7, " "), " (", StringLeftPad(DTP,  4, " "), ")");
               QUOTE  = DoubleToStr(bid, dig);
            
               if(OrderType() == OP_SELLLIMIT)
               {
                  PAIR   = PAIR + " (sl)";
                  if(bid >= entry - (10.01 * factor)) ecolor = Lime;
               }
            
               if(OrderType() == OP_SELLSTOP)
               {
                  PAIR = PAIR + " (ss)";
                  if(bid <= entry + (10.01 * factor)) ecolor = Lime;
               }
            }
         }
         
         if(OrderType() == OP_BUY)
         {
            stop   = (entry - sl) / pnt;
            dsl    = (bid - sl) / pnt;
            dtp    = (tp - bid) / pnt;
            lck    = (sl - entry) / pnt;
            pl     = (cl - entry) / pnt;
            qcolor = Buycolor;
            pcolor = Buycolor;
            
            if(pl >= 0) {plcolor = DeepSkyBlue; PL = StringLeftPad(StringConcatenate("+", DoubleToStr(pl, 0)), 6, " ");}
            else        {plcolor = Tomato;      PL = StringLeftPad(StringConcatenate("-", DoubleToStr(MathAbs(pl), 0)), 6, " ");}
 
            if(bid >= tp - (10.01 * factor) && tp > 0) tpcolor = Lime;
            if(bid <= sl + (10.01 * factor) && sl > 0) slcolor = Red;

            DSL   = DoubleToStr(dsl, 0);
            DTP   = DoubleToStr(dtp, 0);
            LCK   = DoubleToStr(lck, 0);
            QUOTE = DoubleToStr(bid, dig);
            SL    = StringConcatenate(StringLeftPad(DoubleToStr(sl, dig), 7, " "), " (", StringLeftPad(DSL,  4, " "), ")");
            TP    = StringConcatenate(StringLeftPad(DoubleToStr(tp, dig), 7, " "), " (", StringLeftPad(DTP,  4, " "), ")");
            PAIR  = PAIR + " (B)";
         }
         
         if(OrderType() == OP_SELL)
         {
            stop   = (sl - entry) / pnt;
            dsl    = -(ask - sl) / pnt;
            dtp    = -(tp - ask) / pnt;
            lck    = (entry - sl) / pnt;
            pl     = (entry - cl) / pnt;
            qcolor = Sellcolor;
            pcolor = Sellcolor;
            
            if(pl >= 0) {plcolor = DeepSkyBlue; PL = StringLeftPad(StringConcatenate("+", DoubleToStr(pl, 0)), 6, " ");}
            else        {plcolor = Tomato;      PL = StringLeftPad(StringConcatenate("-", DoubleToStr(MathAbs(pl), 0)), 6, " ");}

            if(ask <= tp + (10.01 * factor) && tp > 0) tpcolor = Lime;
            if(ask >= sl - (10.01 * factor) && sl > 0) slcolor = Red;
            
            DSL   = DoubleToStr(dsl, 0);
            DTP   = DoubleToStr(dtp, 0);
            LCK   = DoubleToStr(lck, 0);
            QUOTE = DoubleToStr(ask, dig);
            SL    = StringConcatenate(StringLeftPad(DoubleToStr(sl, dig), 7, " "), " (", StringLeftPad(DSL,  4, " "), ")");
            TP    = StringConcatenate(StringLeftPad(DoubleToStr(tp, dig), 7, " "), " (", StringLeftPad(DTP,  4, " "), ")");
            PAIR  = PAIR + " (S)";
         }
         
         if(sl == 0.0) SL = "_______ (____)";
         if(tp == 0.0) TP = "_______ (____)";
         total1 += pl;
         total2 += pr;
         if(total1 >= 0) {t1color = DeepSkyBlue; TOT1 = StringLeftPad(StringConcatenate("+", DoubleToStr(total1, 0)), 6, " ");}
         else            {t1color = Tomato;      TOT1 = StringLeftPad(StringConcatenate("-", DoubleToStr(MathAbs(total1), 0)), 6, " ");}
         if(total2 >= 0) {t2color = DeepSkyBlue; TOT2 = StringLeftPad(StringConcatenate("+", DoubleToStr(total2, 2)), 9, " ");}
         else            {t2color = Tomato;      TOT2 = StringLeftPad(StringConcatenate("-", DoubleToStr(MathAbs(total2), 2)), 9, " ");}
         
         Calculate_risk(Show_MM);
                  
         Display(TLOBJ + "_T"  + j, ti,    f_syze, F_TYPE, tcolor,  Xpos,      y, Compact_mode);
         Display(TLOBJ + "_S"  + j, PAIR,  f_syze, F_TYPE, pcolor,  Xpos + x1, y, false);
         Display(TLOBJ + "_L"  + j, LO,    f_syze, F_TYPE, lcolor,  Xpos + x2, y, false);
         Display(TLOBJ + "_E"  + j, EN,    f_syze, F_TYPE, ecolor,  Xpos + x3, y, Compact_mode);         
         Display(TLOBJ + "_sl" + j, SL,    f_syze, F_TYPE, slcolor, Xpos + x4, y, Compact_mode);
         Display(TLOBJ + "_tp" + j, TP,    f_syze, F_TYPE, tpcolor, Xpos + x5, y, Compact_mode);
         Display(TLOBJ + "_Q"  + j, QUOTE, f_syze, F_TYPE, qcolor,  Xpos + x6, y, Compact_mode);
         Display(TLOBJ + "_p"  + j, PL,    f_syze, F_TYPE, plcolor, Xpos + x7, y, false);
         Display(TLOBJ + "_pr" + j, PR,    f_syze, F_TYPE, plcolor, Xpos + x8, y, false);
         Display(TLOBJ + "_MM" + j, RK,    f_syze, F_TYPE, rcolor,  Xpos + x9, y, !Show_MM);
         if(Background)
         {
            Display(TLOBJ + "002" + j, BKG0, fontsz, "webdings", bkgcolor, Xpos - 4, y - 3, false);
            if(Show_MM)
               Display(TLOBJ + "003" + j, BKG1, fontsz, "webdings", bkgcolor, Xpos + x9 - 8, y - 3, false);
         }
         
         j = j + 1;
      }
   }

   total1 = 0;
   
   if(Background)
   {
      Display(TLOBJ + "004",  BKG0, fontsz, "webdings", bkgcolor, Xpos - 4, y - 3 + y1, false);
      if(Show_MM)
         Display(TLOBJ + "005",  BKG1, fontsz, "webdings", bkgcolor, Xpos + x9 - 8, y - 3 + y1, false);
   }
   Display(TLOBJ + "tt",      "Total", f_syze, F_TYPE, headcolor, Xpos + x6, y + y1, false);
   Display(TLOBJ + "_t1" + j, TOT1,    f_syze, F_TYPE, t1color,   Xpos + x7, y + y1, false);
   Display(TLOBJ + "_t2" + j, TOT2,    f_syze, F_TYPE, t2color,   Xpos + x8, y + y1, false);
   
   if(OrdersTotal() <= 1)
   {
      ObjectDelete(TLOBJ + "tt");
      ObjectDelete(TLOBJ + "_t1" + j);
      ObjectDelete(TLOBJ + "_t2" + j);
      ObjectDelete(TLOBJ + "004");
      ObjectDelete(TLOBJ + "005");
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void Display(string name, string TEXT, int size, string type, color clr, double X, double Y, bool compact)
{
   if(compact) return (-1);
   ObjectDelete (name);
   ObjectCreate (name, OBJ_LABEL, W, 0, 0);   
      ObjectSet (name, OBJPROP_CORNER, C);
      ObjectSet (name, OBJPROP_XDISTANCE, X);
      ObjectSet (name, OBJPROP_YDISTANCE, Y);
      ObjectSet (name, OBJPROP_BACK, false);
   ObjectSetText(name, TEXT, size, type, clr);
}

void Display_bal(string name, string TEXT, int size, string type, color clr, double X, double Y)
{
   ObjectDelete (name);
   ObjectCreate (name, OBJ_LABEL, w, 0, 0);   
      ObjectSet (name, OBJPROP_CORNER, c);
      ObjectSet (name, OBJPROP_XDISTANCE, X);
      ObjectSet (name, OBJPROP_YDISTANCE, Y);
      ObjectSet (name, OBJPROP_BACK, false);
   ObjectSetText(name, TEXT, size, type, clr);
}

void Calculate_risk(bool mm)
{
   if(!mm) return (-1);
   rcolor = MediumSeaGreen;
   if(sl == 0)     {RK = "Set Stop Loss!!"; rcolor = Yellow;     return(0);}
   if(sl == entry) {RK = "Break Even";      rcolor = WhiteSmoke; return(0);}   
   dig1 = 4;
   if(tkv == 1 || tkv == 10) dig1 = 2;
   size  = stop * lots * tkv;
   prcnt = size / fmg * 100;
   if(prcnt > Risk) rcolor = Red;
   RK = StringConcatenate(DoubleToStr(size, 2), SYMB, " (", DoubleToStr(prcnt, 2), "%) - VSR: ", DoubleToStr(lots * stop, 2), " - ", DoubleToStr(tkv, dig1), SYMB, "/pip");
   
   if((OrderType() == OP_BUY && sl > entry) || (OrderType() == OP_SELL && sl < entry))
   {
      RK = StringConcatenate(LCK, " pips Locked  (", DoubleToStr(lck * tkv * lots, 2), SYMB, ")");
      rcolor = Lime;
   }
}

string StringRepeat(string str, int n = 1)
{
  string outstr = "";
  for(int i = 0; i < n; i++) outstr = outstr + str;
  return(outstr);
}

string StringLeftPad(string str, int n = 1, string str2 = " ")
{
  return(StringRepeat(str2, n - StringLen(str)) + str);
}